Index: src/xend_internal.c
===================================================================
RCS file: /data/cvs/libvirt/src/xend_internal.c,v
retrieving revision 1.124
diff -u -p -r1.124 xend_internal.c
--- src/xend_internal.c	26 Jun 2007 11:42:46 -0000	1.124
+++ src/xend_internal.c	26 Jun 2007 14:27:05 -0000
@@ -35,6 +35,7 @@
 #include "internal.h"
 #include "sexpr.h"
 #include "xml.h"
+#include "buf.h"
 #include "xen_unified.h"
 #include "xend_internal.h"
 #include "xen_internal.h" /* for DOM0_INTERFACE_VERSION */
@@ -249,7 +250,7 @@ do_connect(virConnectPtr xend)
  * wr_sync:
  * @xend: the xend connection object
  * @fd:  the file descriptor
- * @buffer: the I/O buffer
+ * @buf: the I/O buffer
  * @size: the size of the I/O
  * @do_read: write operation if 0, read operation otherwise
  *
@@ -258,7 +259,7 @@ do_connect(virConnectPtr xend)
  * Returns the number of bytes exchanged, or -1 in case of error
  */
 static size_t
-wr_sync(virConnectPtr xend, int fd, void *buffer, size_t size, int do_read)
+wr_sync(virConnectPtr xend, int fd, void *buf, size_t size, int do_read)
 {
     size_t offset = 0;
 
@@ -266,9 +267,9 @@ wr_sync(virConnectPtr xend, int fd, void
         ssize_t len;
 
         if (do_read) {
-            len = read(fd, ((char *) buffer) + offset, size - offset);
+            len = read(fd, ((char *) buf) + offset, size - offset);
         } else {
-            len = write(fd, ((char *) buffer) + offset, size - offset);
+            len = write(fd, ((char *) buf) + offset, size - offset);
         }
 
         /* recoverable error, retry  */
@@ -303,7 +304,7 @@ wr_sync(virConnectPtr xend, int fd, void
  * sread:
  * @xend: the xend connection object
  * @fd:  the file descriptor
- * @buffer: the I/O buffer
+ * @buf: the I/O buffer
  * @size: the size of the I/O
  *
  * Internal routine to do a synchronous read
@@ -311,16 +312,16 @@ wr_sync(virConnectPtr xend, int fd, void
  * Returns the number of bytes read, or -1 in case of error
  */
 static ssize_t
-sread(virConnectPtr xend, int fd, void *buffer, size_t size)
+sread(virConnectPtr xend, int fd, void *buf, size_t size)
 {
-    return wr_sync(xend, fd, buffer, size, 1);
+    return wr_sync(xend, fd, buf, size, 1);
 }
 
 /**
  * swrite:
  * @xend: the xend connection object
  * @fd:  the file descriptor
- * @buffer: the I/O buffer
+ * @buf: the I/O buffer
  * @size: the size of the I/O
  *
  * Internal routine to do a synchronous write
@@ -328,9 +329,9 @@ sread(virConnectPtr xend, int fd, void *
  * Returns the number of bytes written, or -1 in case of error
  */
 static ssize_t
-swrite(virConnectPtr xend, int fd, const void *buffer, size_t size)
+swrite(virConnectPtr xend, int fd, const void *buf, size_t size)
 {
-    return wr_sync(xend, fd, (void *) buffer, size, 0);
+    return wr_sync(xend, fd, (void *) buf, size, 0);
 }
 
 /**
@@ -353,7 +354,7 @@ swrites(virConnectPtr xend, int fd, cons
  * sreads:
  * @xend: the xend connection object
  * @fd:  the file descriptor
- * @buffer: the I/O buffer
+ * @buf: the I/O buffer
  * @n_buffer: the size of the I/O buffer
  *
  * Internal routine to do a synchronous read of a line
@@ -361,7 +362,7 @@ swrites(virConnectPtr xend, int fd, cons
  * Returns the number of bytes read, or -1 in case of error
  */
 static ssize_t
-sreads(virConnectPtr xend, int fd, char *buffer, size_t n_buffer)
+sreads(virConnectPtr xend, int fd, char *buf, size_t n_buffer)
 {
     size_t offset;
 
@@ -371,18 +372,18 @@ sreads(virConnectPtr xend, int fd, char 
     for (offset = 0; offset < (n_buffer - 1); offset++) {
         ssize_t ret;
 
-        ret = sread(xend, fd, buffer + offset, 1);
+        ret = sread(xend, fd, buf + offset, 1);
         if (ret == 0)
             break;
         else if (ret == -1)
             return ret;
 
-        if (buffer[offset] == '\n') {
+        if (buf[offset] == '\n') {
             offset++;
             break;
         }
     }
-    buffer[offset] = 0;
+    buf[offset] = 0;
 
     return offset;
 }
@@ -408,18 +409,18 @@ istartswith(const char *haystack, const 
 static int
 xend_req(virConnectPtr xend, int fd, char *content, size_t n_content)
 {
-    char buffer[4096];
+    char buf[4096];
     int content_length = -1;
     int retcode = 0;
 
-    while (sreads(xend, fd, buffer, sizeof(buffer)) > 0) {
-        if (strcmp(buffer, "\r\n") == 0)
+    while (sreads(xend, fd, buf, sizeof(buf)) > 0) {
+        if (strcmp(buf, "\r\n") == 0)
             break;
 
-        if (istartswith(buffer, "Content-Length: "))
-            content_length = atoi(buffer + 16);
-        else if (istartswith(buffer, "HTTP/1.1 "))
-            retcode = atoi(buffer + 9);
+        if (istartswith(buf, "Content-Length: "))
+            content_length = atoi(buf + 16);
+        else if (istartswith(buf, "HTTP/1.1 "))
+            retcode = atoi(buf + 9);
     }
 
     if (content_length > -1) {
@@ -499,7 +500,7 @@ static int
 xend_post(virConnectPtr xend, const char *path, const char *ops,
           char *content, size_t n_content)
 {
-    char buffer[100];
+    char buf[100];
     int ret;
     int s = do_connect(xend);
 
@@ -515,8 +516,8 @@ xend_post(virConnectPtr xend, const char
             "Accept-Encoding: identity\r\n"
             "Content-Type: application/x-www-form-urlencoded\r\n"
             "Content-Length: ");
-    snprintf(buffer, sizeof(buffer), "%d", (int) strlen(ops));
-    swrites(xend ,s, buffer);
+    snprintf(buf, sizeof(buf), "%d", (int) strlen(ops));
+    swrites(xend ,s, buf);
     swrites(xend, s, "\r\n\r\n");
     swrites(xend, s, ops);
 
@@ -594,7 +595,7 @@ xend_op_ext2(virConnectPtr xend, const c
              size_t n_error, const char *key, va_list ap)
 {
     const char *k = key, *v;
-    virBuffer buf;
+    buffer buf;
     int ret;
 
     buf.content = malloc(1000);
@@ -608,13 +609,13 @@ xend_op_ext2(virConnectPtr xend, const c
     while (k) {
         v = va_arg(ap, const char *);
 
-        virBufferVSprintf(&buf, "%s", k);
-        virBufferVSprintf(&buf, "%s", "=");
-        virBufferVSprintf(&buf, "%s", v);
+        bufferVSprintf(&buf, "%s", k);
+        bufferVSprintf(&buf, "%s", "=");
+        bufferVSprintf(&buf, "%s", v);
         k = va_arg(ap, const char *);
 
         if (k)
-            virBufferVSprintf(&buf, "%s", "&");
+            bufferVSprintf(&buf, "%s", "&");
     }
 
     ret = http2unix(xend, xend_post(xend, path, buf.content, error, n_error));
@@ -670,14 +671,14 @@ static int
 xend_op_ext(virConnectPtr xend, const char *name, char *error,
             size_t n_error, const char *key, ...)
 {
-    char buffer[1024];
+    char buf[1024];
     va_list ap;
     int ret;
 
-    snprintf(buffer, sizeof(buffer), "/xend/domain/%s", name);
+    snprintf(buf, sizeof(buf), "/xend/domain/%s", name);
 
     va_start(ap, key);
-    ret = xend_op_ext2(xend, buffer, error, n_error, key, ap);
+    ret = xend_op_ext2(xend, buf, error, n_error, key, ap);
     va_end(ap);
 
     return ret;
@@ -699,7 +700,7 @@ xend_op_ext(virConnectPtr xend, const ch
 static struct sexpr *
 sexpr_get(virConnectPtr xend, const char *fmt, ...)
 {
-    char buffer[4096];
+    char buf[4096];
     char path[1024];
     va_list ap;
     int ret;
@@ -708,12 +709,12 @@ sexpr_get(virConnectPtr xend, const char
     vsnprintf(path, sizeof(path), fmt, ap);
     va_end(ap);
 
-    ret = xend_get(xend, path, buffer, sizeof(buffer));
+    ret = xend_get(xend, path, buf, sizeof(buf));
     ret = http2unix(xend ,ret);
     if (ret == -1)
         return NULL;
 
-    return string2sexpr(buffer);
+    return string2sexpr(buf);
 }
 
 /**
@@ -810,11 +811,11 @@ static char *
 urlencode(const char *string)
 {
     size_t len = strlen(string);
-    char *buffer = malloc(len * 3 + 1);
-    char *ptr = buffer;
+    char *buf = malloc(len * 3 + 1);
+    char *ptr = buf;
     size_t i;
 
-    if (buffer == NULL) {
+    if (buf == NULL) {
 	virXendError(NULL, VIR_ERR_NO_MEMORY, _("allocate new buffer"));
         return (NULL);
     }
@@ -833,7 +834,7 @@ urlencode(const char *string)
 
     *ptr = 0;
 
-    return buffer;
+    return buf;
 }
 #endif /* ! PROXY */
 
@@ -1215,9 +1216,9 @@ xend_node_restart(virConnectPtr xend)
  * Returns 0 on success; -1 (with errno) on error
  */
 int
-xend_dmesg(virConnectPtr xend, char *buffer, size_t n_buffer)
+xend_dmesg(virConnectPtr xend, char *buf, size_t n_buffer)
 {
-    return http2unix(xend, xend_get(xend, "/xend/node/dmesg", buffer, n_buffer));
+    return http2unix(xend, xend_get(xend, "/xend/node/dmesg", buf, n_buffer));
 }
 
 /**
@@ -1238,7 +1239,7 @@ xend_dmesg_clear(virConnectPtr xend)
 /**
  * xend_log:
  * @xend: A xend instance
- * @buffer: The buffer to hold the messages
+ * @buf: The buffer to hold the messages
  * @n_buffer: Size of buffer (including null terminator)
  *
  * This function will place the Xend debugging messages into
@@ -1247,9 +1248,9 @@ xend_dmesg_clear(virConnectPtr xend)
  * Returns 0 on success; -1 (with errno) on error
  */
 int
-xend_log(virConnectPtr xend, char *buffer, size_t n_buffer)
+xend_log(virConnectPtr xend, char *buf, size_t n_buffer)
 {
-    return http2unix(xend, xend_get(xend, "/xend/node/log", buffer, n_buffer));
+    return http2unix(xend, xend_get(xend, "/xend/node/log", buf, n_buffer));
 }
 #endif /* PROXY */
 
@@ -1278,7 +1279,7 @@ xend_log(virConnectPtr xend, char *buffe
  * Returns 0 in case of success and -1 in case of error
  */
 static int
-xend_parse_sexp_desc_os(virConnectPtr xend, struct sexpr *node, virBufferPtr buf, int hvm, int bootloader)
+xend_parse_sexp_desc_os(virConnectPtr xend, struct sexpr *node, bufferPtr buf, int hvm, int bootloader)
 {
     const char *tmp;
 
@@ -1286,9 +1287,9 @@ xend_parse_sexp_desc_os(virConnectPtr xe
        return(-1);
     }
     
-    virBufferAdd(buf, "  <os>\n", 7);
+    bufferAdd(buf, "  <os>\n", 7);
     if (hvm) {
-        virBufferVSprintf(buf, "    <type>hvm</type>\n");
+        bufferVSprintf(buf, "    <type>hvm</type>\n");
         tmp = sexpr_node(node, "domain/image/hvm/kernel");
         if (tmp == NULL && !bootloader) {
             virXendError(xend, VIR_ERR_INTERNAL_ERROR,
@@ -1296,13 +1297,13 @@ xend_parse_sexp_desc_os(virConnectPtr xe
             return(-1);
         }
         if (tmp)
-            virBufferVSprintf(buf, "    <loader>%s</loader>\n", tmp);
+            bufferVSprintf(buf, "    <loader>%s</loader>\n", tmp);
         tmp = sexpr_node(node, "domain/image/hvm/boot");
         if ((tmp != NULL) && (tmp[0] != 0)) {
             while (*tmp) {
                 if (*tmp == 'a')
                     /* XXX no way to deal with boot from 2nd floppy */
-                    virBufferAdd(buf, "    <boot dev='fd'/>\n", 21 );
+                    bufferAdd(buf, "    <boot dev='fd'/>\n", 21 );
                 else if (*tmp == 'c')
                     /*
                      * Don't know what to put here.  Say the vm has been given 3
@@ -1310,16 +1311,16 @@ xend_parse_sexp_desc_os(virConnectPtr xe
                      * We're going to assume that first disk is the boot disk since
                      * this is most common practice
                      */
-                    virBufferAdd(buf, "    <boot dev='hd'/>\n", 21 );
+                    bufferAdd(buf, "    <boot dev='hd'/>\n", 21 );
                 else if (*tmp == 'd')
-                    virBufferAdd(buf, "    <boot dev='cdrom'/>\n", 24 );
+                    bufferAdd(buf, "    <boot dev='cdrom'/>\n", 24 );
                 else if (*tmp == 'n')
-                    virBufferAdd(buf, "    <boot dev='network'/>\n", 26 );
+                    bufferAdd(buf, "    <boot dev='network'/>\n", 26 );
                 tmp++;
             }
         }
     } else {
-        virBufferVSprintf(buf, "    <type>linux</type>\n");
+        bufferVSprintf(buf, "    <type>linux</type>\n");
         tmp = sexpr_node(node, "domain/image/linux/kernel");
         if (tmp == NULL && !bootloader) {
             virXendError(xend, VIR_ERR_INTERNAL_ERROR,
@@ -1327,19 +1328,19 @@ xend_parse_sexp_desc_os(virConnectPtr xe
             return(-1);
         }
         if (tmp)
-            virBufferVSprintf(buf, "    <kernel>%s</kernel>\n", tmp);
+            bufferVSprintf(buf, "    <kernel>%s</kernel>\n", tmp);
         tmp = sexpr_node(node, "domain/image/linux/ramdisk");
         if ((tmp != NULL) && (tmp[0] != 0))
-           virBufferVSprintf(buf, "    <initrd>%s</initrd>\n", tmp);
+           bufferVSprintf(buf, "    <initrd>%s</initrd>\n", tmp);
         tmp = sexpr_node(node, "domain/image/linux/root");
         if ((tmp != NULL) && (tmp[0] != 0))
-           virBufferVSprintf(buf, "    <root>%s</root>\n", tmp);
+           bufferVSprintf(buf, "    <root>%s</root>\n", tmp);
         tmp = sexpr_node(node, "domain/image/linux/args");
         if ((tmp != NULL) && (tmp[0] != 0))
-           virBufferVSprintf(buf, "    <cmdline>%s</cmdline>\n", tmp);
+           bufferVSprintf(buf, "    <cmdline>%s</cmdline>\n", tmp);
     }
 
-    virBufferAdd(buf, "  </os>\n", 8);
+    bufferAdd(buf, "  </os>\n", 8);
     return(0);
 }
 
@@ -1361,7 +1362,7 @@ xend_parse_sexp_desc(virConnectPtr conn,
     struct sexpr *cur, *node;
     const char *tmp;
     char *tty;
-    virBuffer buf;
+    buffer buf;
     int hvm = 0, bootloader = 0;
     int domid = -1;
     int max_mem, cur_mem;
@@ -1387,7 +1388,7 @@ xend_parse_sexp_desc(virConnectPtr conn,
         domid = sexpr_int(root, "domain/domid");
     else
         domid = -1;
-    virBufferVSprintf(&buf, "<domain type='xen' id='%d'>\n", domid);
+    bufferVSprintf(&buf, "<domain type='xen' id='%d'>\n", domid);
 
     tmp = sexpr_node(root, "domain/name");
     if (tmp == NULL) {
@@ -1395,7 +1396,7 @@ xend_parse_sexp_desc(virConnectPtr conn,
                      _("domain information incomplete, missing name"));
         goto error;
     }
-    virBufferVSprintf(&buf, "  <name>%s</name>\n", tmp);
+    bufferVSprintf(&buf, "  <name>%s</name>\n", tmp);
     tmp = sexpr_node(root, "domain/uuid");
     if (tmp != NULL) {
         char compact[33];
@@ -1410,19 +1411,19 @@ xend_parse_sexp_desc(virConnectPtr conn,
 	}
 	compact[i] = 0;
 	if (i > 0)
-	    virBufferVSprintf(&buf, "  <uuid>%s</uuid>\n", compact);
+	    bufferVSprintf(&buf, "  <uuid>%s</uuid>\n", compact);
     }
     tmp = sexpr_node(root, "domain/bootloader");
     if (tmp != NULL) {
         bootloader = 1;
-        virBufferVSprintf(&buf, "  <bootloader>%s</bootloader>\n", tmp);
+        bufferVSprintf(&buf, "  <bootloader>%s</bootloader>\n", tmp);
     }
     tmp = sexpr_node(root, "domain/bootloader_args");
     if (tmp != NULL && bootloader) {
         /*
          * Only insert bootloader_args if there is also a bootloader param
          */
-        virBufferVSprintf(&buf, "  <bootloader_args>%s</bootloader_args>\n", tmp);
+        bufferVSprintf(&buf, "  <bootloader_args>%s</bootloader_args>\n", tmp);
     }
 
     if (domid != 0) {
@@ -1436,39 +1437,39 @@ xend_parse_sexp_desc(virConnectPtr conn,
     cur_mem = (int) (sexpr_u64(root, "domain/memory") << 10);
     if (cur_mem > max_mem)
         max_mem = cur_mem;
-    virBufferVSprintf(&buf, "  <memory>%d</memory>\n", max_mem);
+    bufferVSprintf(&buf, "  <memory>%d</memory>\n", max_mem);
     if ((cur_mem >= MIN_XEN_GUEST_SIZE) && (cur_mem != max_mem))
-	virBufferVSprintf(&buf, "  <currentMemory>%d</currentMemory>\n",
+	bufferVSprintf(&buf, "  <currentMemory>%d</currentMemory>\n",
 	                  cur_mem);
-    virBufferVSprintf(&buf, "  <vcpu>%d</vcpu>\n",
+    bufferVSprintf(&buf, "  <vcpu>%d</vcpu>\n",
                       sexpr_int(root, "domain/vcpus"));
     tmp = sexpr_node(root, "domain/on_poweroff");
     if (tmp != NULL)
-        virBufferVSprintf(&buf, "  <on_poweroff>%s</on_poweroff>\n", tmp);
+        bufferVSprintf(&buf, "  <on_poweroff>%s</on_poweroff>\n", tmp);
     tmp = sexpr_node(root, "domain/on_reboot");
     if (tmp != NULL)
-        virBufferVSprintf(&buf, "  <on_reboot>%s</on_reboot>\n", tmp);
+        bufferVSprintf(&buf, "  <on_reboot>%s</on_reboot>\n", tmp);
     tmp = sexpr_node(root, "domain/on_crash");
     if (tmp != NULL)
-        virBufferVSprintf(&buf, "  <on_crash>%s</on_crash>\n", tmp);
+        bufferVSprintf(&buf, "  <on_crash>%s</on_crash>\n", tmp);
 
     if (hvm) {
-        virBufferAdd(&buf, "  <features>\n", 13);
+        bufferAdd(&buf, "  <features>\n", 13);
         if (sexpr_int(root, "domain/image/hvm/acpi"))
-            virBufferAdd(&buf, "    <acpi/>\n", 12);
+            bufferAdd(&buf, "    <acpi/>\n", 12);
         if (sexpr_int(root, "domain/image/hvm/apic"))
-            virBufferAdd(&buf, "    <apic/>\n", 12);
+            bufferAdd(&buf, "    <apic/>\n", 12);
         if (sexpr_int(root, "domain/image/hvm/pae"))
-            virBufferAdd(&buf, "    <pae/>\n", 11);
-        virBufferAdd(&buf, "  </features>\n", 14);
+            bufferAdd(&buf, "    <pae/>\n", 11);
+        bufferAdd(&buf, "  </features>\n", 14);
     }
 
-    virBufferAdd(&buf, "  <devices>\n", 12);
+    bufferAdd(&buf, "  <devices>\n", 12);
 
     /* in case of HVM we have devices emulation */
     tmp = sexpr_node(root, "domain/image/hvm/device_model");
     if ((tmp != NULL) && (tmp[0] != 0))
-        virBufferVSprintf(&buf, "    <emulator>%s</emulator>\n", tmp);
+        bufferVSprintf(&buf, "    <emulator>%s</emulator>\n", tmp);
 
     for (cur = root; cur->kind == SEXPR_CONS; cur = cur->cdr) {
         node = cur->car;
@@ -1588,33 +1589,33 @@ xend_parse_sexp_desc(virConnectPtr conn,
             }
 
             if (!isNoSrcCdrom) {
-                virBufferVSprintf(&buf, "    <disk type='%s' device='%s'>\n",
+                bufferVSprintf(&buf, "    <disk type='%s' device='%s'>\n",
                                   isBlock ? "block" : "file",
                                   cdrom ? "cdrom" : "disk");
                 if (drvType) {
-                    virBufferVSprintf(&buf, "      <driver name='%s' type='%s'/>\n", drvName, drvType);
+                    bufferVSprintf(&buf, "      <driver name='%s' type='%s'/>\n", drvName, drvType);
                 } else {
-                    virBufferVSprintf(&buf, "      <driver name='%s'/>\n", drvName);
+                    bufferVSprintf(&buf, "      <driver name='%s'/>\n", drvName);
                 }
                 if (isBlock) {
-                    virBufferVSprintf(&buf, "      <source dev='%s'/>\n", src);
+                    bufferVSprintf(&buf, "      <source dev='%s'/>\n", src);
                 } else {
-                    virBufferVSprintf(&buf, "      <source file='%s'/>\n", src);
+                    bufferVSprintf(&buf, "      <source file='%s'/>\n", src);
                 }
             } else {
                 /* This case is the cdrom device only */
-                virBufferVSprintf(&buf, "    <disk device='cdrom'>\n");
+                bufferVSprintf(&buf, "    <disk device='cdrom'>\n");
             }
-            virBufferVSprintf(&buf, "      <target dev='%s'/>\n", dst);
+            bufferVSprintf(&buf, "      <target dev='%s'/>\n", dst);
 
 
             /* XXX should we force mode == r, if cdrom==1, or assume
                xend has already done this ? */
             if ((mode != NULL) && (!strcmp(mode, "r")))
-                virBufferVSprintf(&buf, "      <readonly/>\n");
+                bufferVSprintf(&buf, "      <readonly/>\n");
 	    else if ((mode != NULL) && (!strcmp(mode, "w!")))
-                virBufferVSprintf(&buf, "      <shareable/>\n");
-            virBufferAdd(&buf, "    </disk>\n", 12);
+                bufferVSprintf(&buf, "      <shareable/>\n");
+            bufferAdd(&buf, "    </disk>\n", 12);
 
             bad_parse:
             if (drvName)
@@ -1626,48 +1627,48 @@ xend_parse_sexp_desc(virConnectPtr conn,
             tmp2 = sexpr_node(node, "device/vif/script");
             tmp = sexpr_node(node, "device/vif/bridge");
             if ((tmp2 && strstr(tmp2, "bridge")) || tmp) {
-                virBufferVSprintf(&buf, "    <interface type='bridge'>\n");
+                bufferVSprintf(&buf, "    <interface type='bridge'>\n");
                 if (tmp != NULL)
-                    virBufferVSprintf(&buf, "      <source bridge='%s'/>\n",
+                    bufferVSprintf(&buf, "      <source bridge='%s'/>\n",
                                       tmp);
             } else {
-                virBufferVSprintf(&buf, "    <interface type='ethernet'>\n");
+                bufferVSprintf(&buf, "    <interface type='ethernet'>\n");
             }
 
             tmp = sexpr_node(node, "device/vif/vifname");
             if (tmp)
-                virBufferVSprintf(&buf, "      <target dev='%s'/>\n",
+                bufferVSprintf(&buf, "      <target dev='%s'/>\n",
                                   tmp);
             tmp = sexpr_node(node, "device/vif/mac");
             if (tmp)
-                virBufferVSprintf(&buf, "      <mac address='%s'/>\n",
+                bufferVSprintf(&buf, "      <mac address='%s'/>\n",
                                   tmp);
             tmp = sexpr_node(node, "device/vif/ip");
             if (tmp)
-                virBufferVSprintf(&buf, "      <ip address='%s'/>\n",
+                bufferVSprintf(&buf, "      <ip address='%s'/>\n",
                                   tmp);
             if (tmp2)
-                virBufferVSprintf(&buf, "      <script path='%s'/>\n",
+                bufferVSprintf(&buf, "      <script path='%s'/>\n",
                                   tmp2);
 
-            virBufferAdd(&buf, "    </interface>\n", 17);
+            bufferAdd(&buf, "    </interface>\n", 17);
         } else if (sexpr_lookup(node, "device/vfb")) {
             /* New style graphics config for PV guests in >= 3.0.4,
              * or for HVM guests in >= 3.0.5 */
             tmp = sexpr_node(node, "device/vfb/type");
 
             if (tmp && !strcmp(tmp, "sdl")) {
-                virBufferAdd(&buf, "    <graphics type='sdl'/>\n", 27);
+                bufferAdd(&buf, "    <graphics type='sdl'/>\n", 27);
             } else if (tmp && !strcmp(tmp, "vnc")) {
                 int port = xenStoreDomainGetVNCPort(conn, domid);
                 const char *listenAddr = sexpr_node(node, "device/vfb/vnclisten");
                 const char *keymap = sexpr_node(node, "device/vfb/keymap");
-                virBufferVSprintf(&buf, "    <graphics type='vnc' port='%d'", port);
+                bufferVSprintf(&buf, "    <graphics type='vnc' port='%d'", port);
                 if (listenAddr)
-                    virBufferVSprintf(&buf, " listen='%s'", listenAddr);
+                    bufferVSprintf(&buf, " listen='%s'", listenAddr);
                 if (keymap)
-                    virBufferVSprintf(&buf, " keymap='%s'", keymap);
-                virBufferAdd(&buf, "/>\n", 3);
+                    bufferVSprintf(&buf, " keymap='%s'", keymap);
+                bufferAdd(&buf, "/>\n", 3);
             }
         }
     }
@@ -1675,29 +1676,29 @@ xend_parse_sexp_desc(virConnectPtr conn,
     if (hvm) {
         tmp = sexpr_node(root, "domain/image/hvm/fda");
         if ((tmp != NULL) && (tmp[0] != 0)) {
-            virBufferAdd(&buf, "    <disk type='file' device='floppy'>\n", 39);
-            virBufferVSprintf(&buf, "      <source file='%s'/>\n", tmp);
-            virBufferAdd(&buf, "      <target dev='fda'/>\n", 26);
-            virBufferAdd(&buf, "    </disk>\n", 12);
+            bufferAdd(&buf, "    <disk type='file' device='floppy'>\n", 39);
+            bufferVSprintf(&buf, "      <source file='%s'/>\n", tmp);
+            bufferAdd(&buf, "      <target dev='fda'/>\n", 26);
+            bufferAdd(&buf, "    </disk>\n", 12);
         }
         tmp = sexpr_node(root, "domain/image/hvm/fdb");
         if ((tmp != NULL) && (tmp[0] != 0)) {
-            virBufferAdd(&buf, "    <disk type='file' device='floppy'>\n", 39);
-            virBufferVSprintf(&buf, "      <source file='%s'/>\n", tmp);
-            virBufferAdd(&buf, "      <target dev='fdb'/>\n", 26);
-            virBufferAdd(&buf, "    </disk>\n", 12);
+            bufferAdd(&buf, "    <disk type='file' device='floppy'>\n", 39);
+            bufferVSprintf(&buf, "      <source file='%s'/>\n", tmp);
+            bufferAdd(&buf, "      <target dev='fdb'/>\n", 26);
+            bufferAdd(&buf, "    </disk>\n", 12);
         }
 
         /* Old style cdrom config from Xen <= 3.0.2 */
         if (xendConfigVersion == 1) {
             tmp = sexpr_node(root, "domain/image/hvm/cdrom");
             if ((tmp != NULL) && (tmp[0] != 0)) {
-                virBufferAdd(&buf, "    <disk type='file' device='cdrom'>\n", 38);
-                virBufferAdd(&buf, "      <driver name='file'/>\n", 28);
-                virBufferVSprintf(&buf, "      <source file='%s'/>\n", tmp);
-                virBufferAdd(&buf, "      <target dev='hdc'/>\n", 26);
-                virBufferAdd(&buf, "      <readonly/>\n", 18);
-                virBufferAdd(&buf, "    </disk>\n", 12);
+                bufferAdd(&buf, "    <disk type='file' device='cdrom'>\n", 38);
+                bufferAdd(&buf, "      <driver name='file'/>\n", 28);
+                bufferVSprintf(&buf, "      <source file='%s'/>\n", tmp);
+                bufferAdd(&buf, "      <target dev='hdc'/>\n", 26);
+                bufferAdd(&buf, "      <readonly/>\n", 18);
+                bufferAdd(&buf, "    </disk>\n", 12);
             }
         }
     }
@@ -1719,12 +1720,12 @@ xend_parse_sexp_desc(virConnectPtr conn,
                  */
                 if (port == -1 && xendConfigVersion < 2)
                     port = 5900 + domid;
-                virBufferVSprintf(&buf, "    <graphics type='vnc' port='%d'", port);
+                bufferVSprintf(&buf, "    <graphics type='vnc' port='%d'", port);
                 if (listenAddr)
-                    virBufferVSprintf(&buf, " listen='%s'", listenAddr);
+                    bufferVSprintf(&buf, " listen='%s'", listenAddr);
                 if (keymap)
-                    virBufferVSprintf(&buf, " keymap='%s'", keymap);
-                virBufferAdd(&buf, "/>\n", 3);
+                    bufferVSprintf(&buf, " keymap='%s'", keymap);
+                bufferAdd(&buf, "/>\n", 3);
             }
         }
 
@@ -1732,18 +1733,18 @@ xend_parse_sexp_desc(virConnectPtr conn,
         tmp = sexpr_fmt_node(root, "domain/image/%s/sdl", hvm ? "hvm" : "linux");
         if (tmp != NULL) {
             if (tmp[0] == '1')
-                virBufferAdd(&buf, "    <graphics type='sdl'/>\n", 27 );
+                bufferAdd(&buf, "    <graphics type='sdl'/>\n", 27 );
         }
     }
 
     tty = xenStoreDomainGetConsolePath(conn, domid);
     if (tty) {
-        virBufferVSprintf(&buf, "    <console tty='%s'/>\n", tty);
+        bufferVSprintf(&buf, "    <console tty='%s'/>\n", tty);
         free(tty);
     }
 
-    virBufferAdd(&buf, "  </devices>\n", 13);
-    virBufferAdd(&buf, "</domain>\n", 10);
+    bufferAdd(&buf, "  </devices>\n", 13);
+    bufferAdd(&buf, "</domain>\n", 10);
 
     buf.content[buf.use] = 0;
     return (ret);
